"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _certVerifierJs = require("cert-verifier-js");

var _reactTimestamp = _interopRequireDefault(require("react-timestamp"));

var _core = require("@material-ui/core");

var _icons = require("@material-ui/icons");

var _blockcertsLogo = _interopRequireDefault(require("../assets/images/blockcertsLogo"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var styles = function styles(theme) {
  return {
    root: {
      overflow: 'hidden',
      padding: theme.spacing(4),
      backgroundColor: '#02112a'
    },
    logo: {
      textAlign: 'center',
      marginBottom: theme.spacing(8)
    },
    stepperRoot: {
      paddingLeft: 0,
      paddingRight: 0,
      backgroundColor: '#02112a'
    },
    step: {
      color: '#ffffff !important'
    },
    text: {
      color: '#ffffff'
    },
    textCenter: {
      color: '#ffffff',
      textAlign: 'center'
    },
    verificationResult: {
      color: '#ffffff',
      textAlign: 'center',
      marginBottom: theme.spacing(4)
    },
    verificationResultCaption: {
      color: '#ffffff',
      display: 'block',
      wordWrap: 'break-word'
    },
    buttons: {
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'center',
      marginTop: theme.spacing(4),
      marginBottom: theme.spacing(4)
    },
    buttonOutlined: {
      borderColor: '#ffffff',
      '&:hover': {
        backgroundColor: 'rgba(255, 255, 255, 0.08)'
      },
      marginBottom: theme.spacing(2)
    },
    buttonIcon: {
      marginRight: theme.spacing(1)
    },
    dialogContentRoot: {
      textAlign: 'justify'
    },
    reactJson: {
      marginBottom: theme.spacing(1)
    },
    expansionPanelDetailsRoot: {
      display: 'block'
    },
    buttonMargin: {
      marginBottom: theme.spacing(2)
    }
  };
};

var Blockcerts =
/*#__PURE__*/
function (_Component) {
  _inherits(Blockcerts, _Component);

  function Blockcerts(props) {
    var _this;

    _classCallCheck(this, Blockcerts);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Blockcerts).call(this, props));
    _this.state = {
      src: null,
      error: null,
      certificate: null,
      verificationSteps: [],
      verificationStep: null,
      verificationResult: null,
      dialogOpen: false
    };
    return _this;
  }

  _createClass(Blockcerts, [{
    key: "handleDialog",
    value: function handleDialog() {
      var dialogOpen = this.state.dialogOpen;
      dialogOpen = !dialogOpen;
      this.setState({
        dialogOpen: dialogOpen
      });
    }
  }, {
    key: "handleVerifyCertificate",
    value: function handleVerifyCertificate() {
      var _this2 = this;

      var _this$state, certificate, verificationSteps, verificationResult;

      return regeneratorRuntime.async(function handleVerifyCertificate$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this$state = this.state, certificate = _this$state.certificate, verificationSteps = _this$state.verificationSteps;
              _context.prev = 1;
              _context.next = 4;
              return regeneratorRuntime.awrap(certificate.verify(function (_ref) {
                var code = _ref.code,
                    label = _ref.label,
                    status = _ref.status,
                    errorMessage = _ref.errorMessage;

                if (status !== 'starting') {
                  verificationSteps.push({
                    code: code,
                    label: label,
                    status: status,
                    errorMessage: errorMessage
                  });
                  var verificationStep = verificationSteps.length - 1;

                  _this2.setState({
                    verificationSteps: verificationSteps,
                    verificationStep: verificationStep
                  });
                }
              }));

            case 4:
              verificationResult = _context.sent;

              if (verificationResult.status === 'success') {
                this.setState({
                  verificationStep: 999
                });
              }

              this.setState({
                verificationResult: verificationResult
              });
              _context.next = 12;
              break;

            case 9:
              _context.prev = 9;
              _context.t0 = _context["catch"](1);
              this.setState({
                error: _context.t0.message
              });

            case 12:
            case "end":
              return _context.stop();
          }
        }
      }, null, this, [[1, 9]]);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var src, response, certificate;
      return regeneratorRuntime.async(function componentDidMount$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (this.state.certificate) {
                _context2.next = 20;
                break;
              }

              src = this.props.src;

              if (!(typeof src === 'string')) {
                _context2.next = 15;
                break;
              }

              _context2.prev = 3;
              _context2.next = 6;
              return regeneratorRuntime.awrap(window.fetch(src));

            case 6:
              response = _context2.sent;
              _context2.next = 9;
              return regeneratorRuntime.awrap(response.json());

            case 9:
              src = _context2.sent;
              _context2.next = 15;
              break;

            case 12:
              _context2.prev = 12;
              _context2.t0 = _context2["catch"](3);
              this.setState({
                error: _context2.t0.message
              });

            case 15:
              if (!(_typeof(src) === 'object')) {
                _context2.next = 20;
                break;
              }

              _context2.next = 18;
              return regeneratorRuntime.awrap(new _certVerifierJs.Certificate(src));

            case 18:
              certificate = _context2.sent;
              this.setState({
                src: src,
                certificate: certificate
              });

            case 20:
              if (this.state.certificate) {
                this.handleVerifyCertificate();
              }

            case 21:
            case "end":
              return _context2.stop();
          }
        }
      }, null, this, [[3, 12]]);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var classes = this.props.classes;
      var _this$state2 = this.state,
          src = _this$state2.src,
          error = _this$state2.error,
          certificate = _this$state2.certificate,
          verificationSteps = _this$state2.verificationSteps,
          verificationStep = _this$state2.verificationStep,
          verificationResult = _this$state2.verificationResult,
          dialogOpen = _this$state2.dialogOpen;

      if (error) {
        return _react["default"].createElement(_core.Typography, {
          color: "error"
        }, error);
      }

      if (!src || !certificate) {
        return _react["default"].createElement(_core.CircularProgress, null);
      }

      return _react["default"].createElement("div", {
        className: classes.root
      }, _react["default"].createElement(_core.Grid, {
        container: true,
        spacing: 4
      }, _react["default"].createElement(_core.Grid, {
        item: true,
        xs: 12,
        md: 9
      }, _react["default"].createElement(_core.Paper, null, src.displayHtml && _react["default"].createElement("div", {
        dangerouslySetInnerHTML: {
          __html: src.displayHtml.replace(/(<? *script)/gi, 'illegalscript')
        }
      }), !src.displayHtml && _react["default"].createElement("div", null, _react["default"].createElement("img", {
        src: certificate.certificateImage,
        className: classes.image
      }), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        variant: "h1"
      }, certificate.title), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        variant: "subheading"
      }, certificate.subtitle), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        variant: "caption"
      }, "Awarded on ", _react["default"].createElement(_reactTimestamp["default"], {
        time: src.issuedOn.toString(),
        format: "full"
      }), " to"), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        variant: "title"
      }, certificate.name), _react["default"].createElement(_core.Typography, {
        paragraph: true
      }, certificate.description), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        variant: "caption"
      }, "Issued by"), _react["default"].createElement("img", {
        src: certificate.sealImage,
        className: classes.image
      }), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        variant: "title"
      }, certificate.issuer.name), _react["default"].createElement(_core.Typography, {
        paragraph: true
      }, certificate.issuer.description), _react["default"].createElement(_core.Typography, {
        paragraph: true
      }, certificate.issuer.email)))), _react["default"].createElement(_core.Grid, {
        item: true,
        xs: 12,
        md: 3
      }, _react["default"].createElement("div", {
        className: classes.logo
      }, _react["default"].createElement("a", {
        href: "https://www.blockcerts.org/about.html",
        target: "_blank",
        rel: "noopener noreferrer",
        color: "inherit"
      }, _react["default"].createElement("img", {
        src: _blockcertsLogo["default"]
      }))), verificationResult ? verificationResult.status === 'success' ? _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_core.Typography, {
        variant: "h4",
        classes: {
          root: classes.verificationResult
        }
      }, "Valid ", _react["default"].createElement(_icons.CheckCircle, null)), _react["default"].createElement(_core.Typography, {
        variant: "h6",
        classes: {
          root: classes.textCenter
        }
      }, "Issuer"), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        classes: {
          root: classes.textCenter
        }
      }, src.badge.issuer.name), _react["default"].createElement(_core.Typography, {
        variant: "h6",
        classes: {
          root: classes.textCenter
        }
      }, "Recipient"), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        classes: {
          root: classes.textCenter
        }
      }, src.recipientProfile.name), _react["default"].createElement(_core.Typography, {
        variant: "h6",
        classes: {
          root: classes.textCenter
        }
      }, "Date"), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        classes: {
          root: classes.textCenter
        }
      }, src.issuedOn), _react["default"].createElement("div", {
        className: classes.buttons
      }, _react["default"].createElement(_core.Button, {
        onClick: function onClick() {
          return _this3.handleDialog();
        },
        color: "inherit",
        size: "small",
        variant: "outlined",
        classes: {
          label: classes.text,
          outlined: classes.buttonOutlined
        }
      }, "Is it really valid?"), _react["default"].createElement(_core.Button, {
        href: "https://github.com/guix77/react-blockcerts#react-blockcerts",
        target: "react-blockcerts",
        rel: "noopener noreferrer",
        color: "inherit",
        size: "small",
        variant: "outlined",
        classes: {
          label: classes.text,
          outlined: classes.buttonOutlined
        }
      }, "About this viewer"))) : _react["default"].createElement(_core.Typography, {
        variant: "h4",
        classes: {
          root: classes.verificationResult
        }
      }, "Invalid ", _react["default"].createElement(_icons.Warning, null)) : _react["default"].createElement(_core.Typography, {
        variant: "h4",
        classes: {
          root: classes.verificationResult
        }
      }, "Verifying ", _react["default"].createElement(_core.CircularProgress, {
        size: 22,
        classes: {
          root: classes.text
        }
      })), (!verificationResult || verificationResult.status !== 'success') && _react["default"].createElement(_core.Stepper, {
        activeStep: verificationStep,
        orientation: "vertical",
        classes: {
          root: classes.stepperRoot
        }
      }, verificationSteps.map(function (step, index) {
        return _react["default"].createElement(_core.Step, {
          key: index
        }, _react["default"].createElement(_core.StepLabel, {
          error: step.status === 'failure',
          classes: {
            label: classes.step
          },
          StepIconProps: {
            classes: {
              root: classes.step
            }
          }
        }, step.label));
      })))), verificationResult && verificationResult.status === 'success' && _react["default"].createElement(_core.Dialog, {
        open: dialogOpen,
        onClose: function onClose() {
          return _this3.handleDialog();
        },
        fullWidth: true,
        maxWidth: "md"
      }, _react["default"].createElement(_core.DialogContent, {
        classes: {
          root: classes.dialogContentRoot
        }
      }, _react["default"].createElement(_core.Typography, {
        variant: "h4",
        gutterBottom: true,
        paragraph: true
      }, "Is this certificate really valid?"), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "You have to check that the following URL is really hosted on the official Issuer's website: ".concat(certificate.issuer.id)), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "You also have to decide if the current website can be trusted (it's not necessarly the same as the one above): ".concat(window.location.origin)), _react["default"].createElement(_core.ExpansionPanel, null, _react["default"].createElement(_core.ExpansionPanelSummary, {
        expandIcon: _react["default"].createElement(_icons.ExpandMore, null)
      }, _react["default"].createElement(_core.Typography, null, "I want to know more!")), _react["default"].createElement(_core.ExpansionPanelDetails, {
        classes: {
          root: classes.expansionPanelDetailsRoot
        }
      }, _react["default"].createElement(_core.Typography, {
        variant: "h4",
        gutterBottom: true,
        paragraph: true
      }, "The verification process"), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "Let's display again the verification steps:"), _react["default"].createElement(_core.Stepper, {
        activeStep: -1,
        orientation: "vertical"
      }, verificationSteps.map(function (step, index) {
        return _react["default"].createElement(_core.Step, {
          key: index
        }, _react["default"].createElement(_core.StepLabel, {
          error: step.status === 'failure'
        }, step.label));
      })), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "Not so easy, right? Let's try to explain this easily."), _react["default"].createElement(_core.Typography, {
        variant: "h5",
        gutterBottom: true,
        paragraph: true
      }, "The transaction"), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "Any action on any blockchain is executed by submitting a transaction. In this case, the Issuer signed a transaction to certify this certificate and we need to check if this transaction exists to validate the certificate."), _react["default"].createElement(_core.Typography, {
        variant: "h5",
        gutterBottom: true,
        paragraph: true
      }, "The identity problem on the blockchain"), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "So the Issuer, a university for instance, could just have an account on the blockchain, and add certificates. The problem is in most blockchains, accounts are anonymous. We can only know that a certain \"strange\" address like 0xabcd... did something on the blockchain, but not know who it is. That's why all Issuers must declare their official blockchain address on their official website, so it can be later verified that the address that signed this transaction belongs to the university. This is what we call the \"Issuer profile\"."), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "This certificate Issuer profile URL is ".concat(src.badge.issuer.id)), _react["default"].createElement(_core.Button, {
        href: src.badge.issuer.id,
        target: "issuer",
        rel: "noopener noreferrer",
        startIcon: _react["default"].createElement(_icons.Link, null),
        color: "primary",
        className: classes.buttonMargin
      }, "Click to open Issuer profile URL and see its content."), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "If you clicked, notice the \"publicKey\": it's the blockchain address of the Issuer!"), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "Unfortunately, currently, there is a weakness in the Blockcerts 2.0 standard that can be exploited by a hacker to pretend to be an Issuer that she / he IS NOT, in hosting a fake Issuer profile on his own server. That's why we asked you to check that this URL is really on the official Issuer's website. There are very interesting projects currently trying to fix that issue in a near future, but so far it's not yet fixed."), _react["default"].createElement(_core.Typography, {
        variant: "h5",
        gutterBottom: true,
        paragraph: true
      }, "The data problem on the blockchain"), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "So now that the identity problem is solved, let's just add the certificate on the blockchain, right? Well, it's not that simple. Writing data on blockchain is extremely expensive, and on the Bitcoin blockchain, not even possible for complex data such as certificates. So instead of storing all the certificate data on the blockchain, we just store what we call their \"hash\" in computer science."), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "See the fridge in your kitchen? Instead of certifying all the infinite complex arrangement of atoms it is made of, we just certify its serial number."), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "Now it will be possible to check that the hash of this certificate was recorded in the blockchain transaction and therefore, verify the certificate."), _react["default"].createElement(_core.Typography, {
        variant: "h5",
        gutterBottom: true,
        paragraph: true
      }, "Mass issuance of certificates"), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "All right, we solved the data problem too, let's store a certificate hash on the blockchain! Well... we could. But what if want to issue a degree to 1000 students? Instead of repeating the process for each student, we would like to issue all those certificates at the same time. To do this, we use a cryptography concept called \"Merle tree\"."), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "Picture yourself an oak tree. Instead of certifying each leaf, we can just certify the root of the oak tree. We can later proove that a given leaf belongs to this exact tree, and therefore that this leaf is certified."), _react["default"].createElement(_core.Typography, {
        variant: "h5",
        gutterBottom: true,
        paragraph: true
      }, "The immutability \"problem\""), _react["default"].createElement(_core.Typography, {
        gutterBottom: true,
        paragraph: true
      }, "As if it wasn't complex enough, by blockchain design it is impossible to remove a transaction. So the Issuer can not \"unsign\" a certificate. Instead, we can use a revocation list and / or expiration dates.")))), _react["default"].createElement(_core.DialogActions, null, _react["default"].createElement(_core.Button, {
        onClick: function onClick() {
          return _this3.handleDialog();
        }
      }, "Close"))));
    }
  }]);

  return Blockcerts;
}(_react.Component);

Blockcerts.propTypes = {
  src: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]).isRequired
};

var _default = (0, _core.withStyles)(styles)(Blockcerts);

exports["default"] = _default;